Subject: Re: [Netconf] [netmod] FW: I-DAction:draft-linowski-netmod-yang-abstract-00.txt

From: "Ersue, Mehmet (NSN - DE/Munich)" <[email-masked]>
Date: Fri, 24 Jul 2009 14:46:02 +0200

Hi Andy,

From: ext Andy Bierman [mailto:[email-masked]] 
> Ersue, Mehmet (NSN - DE/Munich) wrote:
> > 
> > Hi Balazs,
> > 
> > thank you for pointing this out.
> > 
> > We indeed have a lot to do and the -00 draft is for sure
> > not complete.
> > 
> > Actions/rpcs in groupings/lists and type information on
> > groupings are features we definitely need.
> > We would be happy to have your suggestions and input.
> > 
> 
> 
> Hi,
> 
> Didn't we do a requirements gathering phase of some sort,
> in order to get to the point where charter decisions
> were made, so that the NETMOD WG could proceed and
> finish in finite time?

Yes, we had long discussions on this and decided to start
the work based on the WG items listed in the NETMOD charter.

At the same time, IIRC based on the request of not-negligible
amount of persons we wrote following text into the charter:

"Language abstractions that facilitate model extensibility 
and reuse have been identified as a work area and will be 
considered as a work item or may be integrated into the 
YANG document based on WG consensus."

This was the consensus we had after the requirements and 
NETMOD charter discussion.

BTW: We had similar discussions also later. E.g. we discussed
in the interim meeting on "rpc statement in list".
http://trac.tools.ietf.org/wg/netmod/trac/wiki/Issues_yang#issue-00221
The consensus was not to add it to YANG 1.0 with 
the hope that it'll be considered later. 
 
> I believe the consensus at the time was that we did
> not want an OO data modeling language and we choose YANG over several
> other proposals, including the OO proposal from your co-author.

Actually I don't like the term "OO". It does not explain
what we would like to have. I also don't want YANG to be 
an "object oriented programming language".

But OTOH I want language abstractions and modeling language 
features which support extensibility and top-down modeling.
I don't think it is a contradiction to have both groupings and 
complex types as YANG features. Both have their specialities
and are worth to use for specific purposes.

It is the feature richness which makes a language successful.
Different people will model their YAM on different abstraction 
levels.

Some will use only groupings because they aim to model 
structured data tables. Others will use complex types _and_
groupings because they have a bigger amount of modeling work 
to do. Their system and the huge amount of data models ask 
for top-down design and a hierarchical modeling.

> It is rather subjective to start comparing comfort-levels
> with 1 variant of the IPFIX model or another.  I doubt we
> could reach agreement in the IETF on a data modeling language
> that had enough OO programming language features to make a
> real difference.  I prefer to get a stable YANG 1.0 deployed,
> and start defining some standard content.  

As I wrote in another mail I fully support the targets of the
WG developing YANG 1.0 with the decided set of features.
What we are discussing is relevant for YANG 1.x.

> IMO, the DML used
> would not make much difference at all if I were deciding whether to
> implement the IPFIX model or not.
> 
> 
> > Cheers,
> > Mehmet
> >

Cheers,
Mehmet
> Andy